//console command that swaps the functions of spin and custom 1 for controllers
COM_AddCommand("crash_consolemode", function(player, var)
	if var == "off" or var == "0"
		player.crash_consolemode = false
		CONS_Printf(player, "Console mode is disabled")
	elseif var == "on" or var == "1"
		player.crash_consolemode = true
		CONS_Printf(player, "Console mode is enabled")
	else
		CONS_Printf(player, "Console mode swaps the actions of the spin and " +
				"custom 1 buttons, useful for controller players. Use on/off " +
				"or 1/0 to enable/disable it.")
	end
end, COM_LOCAL)

//a function to make skinchecking easier
CrashAddon.CrashSkinCheck = function(player)
	if player.mo == nil
		return false
	end
	if player.mo.skin != "crashbandi"
		return false
	end
	return true
end

/*this function just makes different jumps easier to manage since they all share
the same setup, ported from Emmette's code*/
CrashAddon.JumpManager = function(mo, hight)
	/*this nerfs the jumps while underwater or in space so that the player 
	doesn't jump way higher underwater than on dry land*/
	if mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(mo)
		hight = $ - ($ / 3)
	end
	P_SetObjectMomZ(mo, hight)
end

//this is ported from Emmette's code to make setting states easier
CrashAddon.StateSetter = function(mo, sstate)
	if mo.state != sstate
		mo.state = sstate
	end
end

//speed calculation because player.speed not be accurate
CrashAddon.SpeedCalc = function(player)
	return FixedHypot(player.mo.momx - player.cmomx, player.mo.momy - player.cmomy)
end

//a function that returns the button to check based on if console mode is on/off
CrashAddon.ActionButton = function(player)
	if player.crash_consolemode
		return BT_CUSTOM1
	else
		return BT_SPIN
	end
end

//this overrides the invincibility function in order to change the music
function A_Invincibility(actor, var1, var2)
	super(actor, var1, var2)
	if actor.target.skin == "crashbandi"
		P_PlayJingleMusic(actor.target.player, "CSHINV", 0, false, JT_INV)
	end
end

//this makes checking for when moves should be disabled easier
CrashAddon.FailVibeCheck = function(player)
	return P_PlayerInPain(player) or player.playerstate == PST_DEAD or
			player.powers[pw_carry] != CR_NONE or player.mo.state ==
			S_PLAY_PAIN
end

//made this a function because i realized i use this check a lot
CrashAddon.CootOnGround = function(mo)
	return P_IsObjectOnGround(mo) or mo.eflags & MFE_JUSTHITFLOOR
end