local CrashSkinCheck = CrashAddon.CrashSkinCheck
local FailVibeCheck = CrashAddon.FailVibeCheck
local CootOnGround = CrashAddon.CootOnGround
local SpeedCalc = CrashAddon.SpeedCalc
local StateSetter = CrashAddon.StateSetter

//funny easter egg
local function EasterEgg(player)
	if not CrashSkinCheck(player)
		return
	end
	
	//this resets everything and prevents moves if crash fails the vibe check
	if FailVibeCheck(player)
		player.crashban.woah = false
		return
	end
	
	if (player.cmd.buttons & BT_CUSTOM3 and player.cmd.buttons & BT_TOSSFLAG) and
			CootOnGround(player.mo) and (SpeedCalc(player) == 0 or 
			P_GetPlayerControlDirection(player) == 0)
		if not player.crashban.woah
			S_StartSound(player.mo, sfx_woah)
			player.crashban.woah = true
		end
	elseif not CootOnGround(player.mo) or (SpeedCalc(player) != 0 and
			P_GetPlayerControlDirection(player) != 0) or player.cmd.buttons &
			BT_SPIN or player.cmd.buttons & BT_CUSTOM1 or player.mo.pflags &
			PF_SPINNING and player.crashban.woah
		player.crashban.woah = false
	end
	if player.crashban.woah
		StateSetter(player.mo, S_PLAY_FLY_TIRED)
	end
end

//funni feature where the tornado spin knocks back other players
local function TornadoKnockback(thing, tmthing)
	if tmthing.skin == "crashbandi" and tmthing.state == S_PLAY_SPINDASH
		if tmthing.z >= thing.z - thing.height and tmthing.z <= thing.z + 
				thing.height
			if not P_PlayerInPain(thing.player) and thing.state != S_PLAY_PAIN
				P_DoPlayerPain(thing.player)
				thing.player.powers[pw_flashing] = 0
				S_StartSound(thing, sfx_cshpew)
			end
		end
	end
end

//hooks
addHook("PlayerThink", EasterEgg)
addHook("MobjCollide", TornadoKnockback, MT_PLAYER)