local CrashSkinCheck = CrashAddon.CrashSkinCheck
local JumpManager = CrashAddon.JumpManager
local FailVibeCheck = CrashAddon.FailVibeCheck
local StateSetter = CrashAddon.StateSetter

//a custom function for setting jump states specifically
local function JumpMode(player)
	if player.mo.state != S_PLAY_JUMP and player.mo.state != S_PLAY_FALL
		player.mo.state = S_PLAY_JUMP
	end
end

//a function since all the different states share the exact same setup
local function JumpAnimations(player, sstate)
	if (player.mo.momz >= -5 * player.mo.scale and player.mo.momz <= 0 and
			player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.momz <= 5 * 
			player.mo.scale and player.mo.momz >= 0 and not 
			(player.mo.eflags & MFE_VERTICALFLIP))
		StateSetter(player.mo, sstate)
	else
		JumpMode(player)
	end
end
	
//just some changes to crash's jump animations based on certain conditions
local function JumpStates(player)
	if not CrashSkinCheck(player) or FailVibeCheck(player) or 
			player.crashban.spintimer > 0 or player.crashban.bodyslam
		return
	end
	
	if player.pflags & PF_JUMPED
		if player.crashban.slidejumped
			JumpAnimations(player, S_PLAY_FLY)
		elseif player.pflags & PF_THOKKED
			if (player.mo.momz <= 0 and player.mo.eflags & MFE_VERTICALFLIP) or 
					(player.mo.momz >= 0 and not (player.mo.eflags & 
					MFE_VERTICALFLIP))
				StateSetter(player.mo, S_PLAY_FLOAT)
			else
				JumpMode(player)
			end
		else
			JumpAnimations(player, S_PLAY_ROLL)
		end
	end
end

//hooks
addHook("PlayerThink", JumpStates)