local CrashSkinCheck = CrashAddon.CrashSkinCheck
local JumpManager = CrashAddon.JumpManager
local FailVibeCheck = CrashAddon.FailVibeCheck
local CootOnGround = CrashAddon.CootOnGround

/*has its own version of the ActionButton function since the spin move is on
different button from crawl/slide and body slam*/
local function ActionButton(player)
	if player.crash_consolemode
		return BT_SPIN
	else
		return BT_CUSTOM1
	end
end

local function TornadoSpinGlide(player)
	if not CrashSkinCheck(player)
		return
	end
	
	//this resets everything and prevents moves if crash fails the vibe check
	if FailVibeCheck(player)
		player.crashban.spincooldown = 0
		player.crashban.buttonpress = false
		player.crashban.glidecounter = 0
		player.crashban.spintimer = 0
		return
	end
	
	if player.crashban.spincooldown <= 0
		//this makes crash start spinning when the button is pressed
		if player.cmd.buttons & ActionButton(player) and not 
				player.crashban.bodyslam and player.crashban.slidetimer <= 0 and
				player.normalspeed != 5 * FRACUNIT and not (player.pflags &
				PF_SPINNING)
			if not player.crashban.buttonpress
				if player.crashban.glidecounter < 8
					player.crashban.spintimer = TICRATE / 2
					S_StartSound(player.mo, sfx_cshspn)
					if CootOnGround(player.mo)
						player.crashban.glidecounter = 8
					else
						player.crashban.glidecounter = $ + 1
					end
				end
				player.crashban.buttonpress = true
			end
		else
			player.crashban.buttonpress = false
		end
		//this makes crash do damage and glide while the spin move is active
		if player.crashban.spintimer > 0
			if player.mo.state != S_PLAY_SPINDASH
				player.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_WALL|STR_SPIKE
				player.mo.state = S_PLAY_SPINDASH
			end
			if not CootOnGround(player.mo) and (player.mo.eflags & 
					MFE_VERTICALFLIP and player.mo.momz > 0) or (not 
					(player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 0)
				JumpManager(player.mo, -3 * FRACUNIT)
			end
			player.crashban.spintimer = $ - 1
		else
			if player.mo.state == S_PLAY_SPINDASH
				if CootOnGround(player.mo)
					player.mo.state = S_PLAY_WALK
				else
					player.mo.state = S_PLAY_FALL
				end
				player.crashban.spincooldown = TICRATE / 2
			end
			if CootOnGround(player.mo)
				player.crashban.glidecounter = 0
			elseif player.crashban.glidecounter > 0
				player.crashban.glidecounter = 8
			end
		end
	else
		if player.mo.state == S_PLAY_SPINDASH
			if CootOnGround(player.mo)
				player.mo.state = S_PLAY_WALK
			else
				player.mo.state = S_PLAY_FALL
			end
		end
		player.crashban.glidecounter = 0
		player.crashban.spincooldown = $ - 1
	end
end

//hooks
addHook("PlayerThink", TornadoSpinGlide)